'use strict';

module.exports = function(o) {
  var style = o.style || noop;

  return {
    bodyContent: function(options) {
      style();

      var React = require('react');

      return React.createClass({
        render: function () {
          return null;
        }
      });
    },
    postProcessItems: function(items) {
      var Prism = require('prismjs');
      var languages = require('prism-languages');
      var highlight = Prism.highlight;
      var _ = require('lodash');
      var he = require('he');
      var cheerio = require('cheerio');

      _.each(items, function (item) {
        if(!item.content) {
          return;
        }

        var $ = cheerio.load(item.content);

        $('code').replaceWith(function(i, e) {
            var $e = $(e);
            var text = $e.text();
            var language = $e.attr('class');

            if(language) {
              language = language.split('-');
              language = language.length > 1 ? language[1] : 'bash';
            }
            else {
              language = 'bash';
            }

            if(text.split('\n').length < 2) {
              return $('<code>' + he.encode(text) + '</code>');
            }

            return $e.html(highlight($e.text(), languages[language]));
        });

        item.content = $.html();
      });

      return items;
    }
  };
};

function noop() {}
